;         " ".
;      .1.   
;  - 1.3, 1.7, 3.0, 3.1, 3.3 - 3.5, 3.7,  
; -  1.2 (   .0).  1.5 
;   .     1.4, 
;  - .0 (     ).
;    1.2      0.
;        3.2.
;   - 4 .
;  20       .
;   892051   TASM.
;  -  . ,  ., . .
;
R0      .EQU 0                  ; R0  R1   
R1      .EQU 1                  ;    0,
R2      .EQU 2                  ; R2, R3   
R3      .EQU 3                  ; ,
R4      .EQU 4                  ; R5  R6   
R5      .EQU 5                  ;   
R6      .EQU 6                  ; R7    
R7      .EQU 7                  ;   
ACC     .EQU 0E0H               ; R4    
P1      .EQU 090H               ;  INT0 (. 3.2)
P3      .EQU 0B0H               ;
P1.2    .EQU 092H               ; , ,  
P1.3    .EQU 093H               ;  
P1.4    .EQU 094H               ;
P1.5    .EQU 0945               ;
P1.7    .EQU 097H               ;
P3.2    .EQU 0B2H
P3.6    .EQU 0B6H
TR0     .EQU 08CH               ;    0
TH0     .EQU 08CH               ;    0
TL0     .EQU 08AH               ;    0
TMOD    .EQU 089H               ;   0
PCON    .EQU 087H               ;  
EX0     .EQU 0A8H               ;     INT0
IT0     .EQU 088H               ;    0
ET0     .EQU 0A9H               ;     0
EA      .EQU 0AFH               ;  
PSW     .EQU 0D0H               ; 
PT0     .EQU 0B9H               ;  - 0
PX0     .EQU 0B8H               ;    0
;
        .ORG 0
        LJMP WORK
        .ORG 03H
        LJMP POWEROFF
        .ORG 0BH
        LJMP TIMER0
        .ORG 100H
;
WORK:                           ;  0   
        MOV TMOD,#00000001B     ;  0   2 (
                                ;  ,  -
                                ;   TR0)
        MOV TL0,#0CAh           ;
        MOV TH0,#0F5h           ;   0   0F5CAh (62922d)
        SETB EX0                ;    0
        SETB IT0                ;      0
        SETB ET0                ;    0
        SETB EA                 ;  
        CLR PT0                 ;    - 0
        SETB PX0                ;      0
        SETB TR0                ;  0
;
START:
        MOV R4,#0
        MOV P1,#37h             ;  1.0, 1.1,  
                                ; 1.2 - .1 (   )
                                ; 1.4 - .1 ( )
                                ; 1.5 - .1 ( )
        MOV P3,#04h             ; 3.2 - .1 ( )
        SETB C                  ;  
        CLR P1.4                ;  1.4 (  )
        LCALL DEL100MS          ;  100 
        SETB P1.4               ;  1.4 (  )
CYCL:
        JC CYCL2                ; CY=1 (  )   CYCL2
        LJMP EXTCYCL            ; CY=0 (  )   EXTCYCL
CYCL2:                          ;   
        CLR P1.7                ;     1.3, 1.7, 3.0, 3.1
        CLR P1.3                ;3.3 - 3.5  3.7  ,   " "
        MOV P3,#04H             ;  (1.3)   (3.7), 
        LCALL DEL250MS          ;      150 
        SETB P1.3               ; 250   ,   
        LCALL DEL150MS          ; 
        CLR P1.3                ; ,    (150+250)*8=3200 
        LCALL DEL250MS          ;
        SETB P1.7
        LCALL DEL150MS
        CLR P1.7
        LCALL DEL250MS
        MOV P3,#05H
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#06H
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#0CH
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#14H
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#24H
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#84H
        LCALL DEL150MS
        MOV C,P3.6              ;  CY  3.6 (  )
        LJMP CYCL               ;    CYCL
;
EXTCYCL:                        ;  Power Down
        MOV R6,#3
CYCL1:
        DJNZ R6,NEWCYCL         ; R6   0,    NEWCYCL
        LJMP POWRDOWN           ; R6=0,    POWRDOWN
NEWCYCL:
        MOV R5,#187             ;   R5  R6   
PF3:                            ;   POWER DOWN (187*2=374)
        DJNZ R5,PDCYCL          ; R5   0,    PDCYCL
        LJMP CYCL1              ; R5=0,    CYCL
PDCYCL:                         ;    Power Down
        JC CYCL2                ; CY=1 (  )   CYCL2
        MOV R7,#4               ; CY=0 (  )  
PF2:    DJNZ R7,PF1             ;    (   100 
        LJMP CYCL3              ;   100 )
PF1:    CLR P1.4
        LCALL DEL100MS
        SETB P1.4
        LCALL DEL100MS
        LJMP PF2
CYCL3:
        CLR P1.7                ;     " "
        CLR P1.3                ;      
        MOV P3,#04H
        LCALL DEL250MS
        SETB P1.3
        LCALL DEL150MS
        CLR P1.3
        LCALL DEL250MS
        SETB P1.7
        LCALL DEL150MS
        CLR P1.7
        LCALL DEL250MS
        MOV P3,#05H
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#06H
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#0CH
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#14H
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#24H
        LCALL DEL150MS
        MOV P3,#04H
        LCALL DEL250MS
        MOV P3,#84H
        LCALL DEL150MS
        MOV C,P3.6              ;  CY  3.6 (  )
        LJMP PF3                ;    PF3
POWRDOWN:                       ;
        CLR P1.4
        LCALL DEL4S             ;    4 
        MOV P1,#17h
        MOV PCON,#02h
;
DEL50MS:                        ;   50 
        MOV R2,#33              ; 33 
LREX:   MOV R3,#250             ; 1,5 
LRIN:   DJNZ R3,LRIN
        DJNZ R2,LREX
        RET
;
DEL100MS:                       ;   100 
        LCALL DEL50MS
        LCALL DEL50MS
        RET
;
DEL150MS:                       ;   150 
        LCALL DEL100MS
        LCALL DEL50MS
        RET
;
DEL250MS:                       ;   250 
        LCALL DEL150MS
        LCALL DEL100MS
        RET
;
DEL1S:                          ;   1 
        LCALL DEL250MS
        LCALL DEL250MS
        LCALL DEL250MS
        LCALL DEL250MS
        RET
DEL4S:                          ;   4 
        LCALL DEL1S
        LCALL DEL1S
        LCALL DEL1S
        LCALL DEL1S
        RET
;
TIMER0:                         ;     0
        CLR TR0                 ; 0 
        PUSH PSW
        PUSH ACC
        PUSH R2
        PUSH R3
        PUSH R4
        PUSH R5                 ;   
        PUSH R6
        PUSH R7
        SETB P1.2               ;  1.0 ( "" )
        INC R0                  ;  R0
        CJNE R0,#255,START1     ;  R0   255,   START1
        CLR P1.2                ; ,    1.2 ( "" )
        DEC R0                  ;  R0
        INC R1                  ;  R1
        CJNE R1,#12,START1      ;  R1   25,   START1
        SETB P1.2               ; ,   1.0
        MOV R1,#0               ; R1
        MOV R0,#0               ; R0
START1:
        MOV TH0,#0F5h
        MOV TL0,#0CAh           ;   0   0F5CAh (62922d)
        POP R7
        POP R6
        POP R5                  ;   
        POP R4
        POP R3
        POP R2
        POP ACC
        POP PSW                 ;   
        SETB TR0                ;  0
        RETI
;
POWEROFF:                       ;     INT0 (P3.2)
        PUSH PSW                ;( )
        PUSH ACC
        PUSH R0
        PUSH R1
        PUSH R2
        PUSH R3
        PUSH R5                 ;   
        PUSH R6
        PUSH R7
        LCALL DEL50MS           ;  50 
        MOV C,P3.2
        JNC START2
        LJMP START3
START2:
        INC R4
        CJNE R4,#2,START3
        CLR P1.4
        LCALL DEL1S             ;    1 
        MOV P1,#17h
        MOV PCON,#02h
START3:
        POP R7
        POP R6
        POP R5                  ;   
        POP R3
        POP R2
        POP R1
        POP R0
        POP ACC
        POP PSW                 ;   
        RETI
;
        .END

;,     0   R0  R1   ,
;  1.2 ( )     200  
; 2000   ,     .



